-- Dada --

PUIB = {};
PUIB.modDirectory = g_currentModDirectory;

function PUIB.prerequisitesPresent(specializations)
      return true;
end;
function PUIB.initSpecialization()
	local schema = Vehicle.xmlSchema
    schema:setXMLSpecializationType("PUIB")
	schema:register(XMLValueType.INT, "vehicle.puibb#fillUnitIndex", "fillUnitIndex")
	schema:register(XMLValueType.FLOAT, "vehicle.puibb#capa", "capa")
	schema:register(XMLValueType.NODE_INDEX, "vehicle.puibb#Trigger", "Trigger")
end
function PUIB.registerOverwrittenFunctions(vehicleType)
end
function PUIB.registerFunctions(vehicleType)	
end
function PUIB.registerEvents(vehicleType)
end
function PUIB:registerActionEventsPlayer()
end
function PUIB:registerActionEventsMenu()
end

function PUIB.registerEventListeners(vehicleType)
	specializations = {"onLoad", "onDelete", "onUpdateTick", "onReadStream", "onWriteStream"}
	for _, v in pairs(specializations) do
		SpecializationUtil.registerEventListener(vehicleType, v, PUIB)
	end
end

function PUIB:onLoad(vehicle)	
	
	self.RockPUIBTriggerCallback = PUIB.RockPUIBTriggerCallback;
	self.fillUnitIndex = self.xmlFile:getValue("vehicle.puibb#fillUnitIndex")

    self.capa = self.xmlFile:getValue("vehicle.puibb#capa")
	
	self.trigger = self.xmlFile:getValue("vehicle.puibb#Trigger", nil, self.components, self.i3dMappings)
	self.triggerId = addTrigger(self.trigger, "RockPUIBTriggerCallback", self)
	self.vehicle = nil
end;

function PUIB:onDelete() 
		if self.trigger ~= nil then
			removeTrigger(self.trigger)
		end
end;

function PUIB:onUpdateTick(dt, vehicle)
	if self.vehicle ~= nil then
			local vehicle = self.vehicle
			local fillLevel2 = self:getFillUnitFillLevel(self.fillUnitIndex)
            local capacity = vehicle:getFillUnitCapacity(1)
			local TypefillBenne = self:getFillUnitFillType(self.fillUnitIndex)

            local level = vehicle:getFillUnitFillLevel(1)
            local Typefill = vehicle:getFillUnitFillType(1)
			if level < capacity and fillLevel2 > 0 and TypefillBenne == Typefill or Typefill == 1 then
				self:addFillUnitFillLevel(self:getOwnerFarmId(), self.fillUnitIndex, -self.capa, TypefillBenne, ToolType.UNDEFINED, nil)
				vehicle:addFillUnitFillLevel(vehicle:getOwnerFarmId(), 1, self.capa, TypefillBenne, ToolType.UNDEFINED, nil)
			end
	end
end

function PUIB:onReadStream(streamId, connection)
end;
  
function PUIB:onWriteStream(streamId, connection)
end;

function PUIB:RockPUIBTriggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
    if onEnter then
		local vehicle = g_currentMission.nodeToObject[otherShapeId];
		if vehicle ~= nil and vehicle:getFillUnitFillType(1) ~= nil and vehicle ~= self then
			self.vehicle = vehicle
		
		end
	elseif onLeave then
		self.vehicle = nil
	end
end